<template>
  <button type="button"
          class="rui-timeout-button"
          :style="buttonStyle"
          :class="buttonCSS"
          @click="handleClick">
    <span class="rui-timeout-button__background"
          :class="backgroundCSS"
          :style="backgroundStyle" />
    <span class="rui-timeout-button__label">
      <!-- @slot Custom content when timer is running -->
      <slot v-if="processing" name="toggleLabel">
        <rui-icon name="rui:x-bold" />
        {{ $t('rui.generic.cancel') }}
      </slot>
      <!-- @slot -->
      <slot v-else>
        <rui-icon v-if="icon" :name="icon" />
        <span class="rui-timeout-button__label__text">{{ label }}</span>
      </slot>
    </span>
  </button>
</template>

<script>
import RuiIcon from '../../Icon/Icon.vue'

// FIXME: Make this coherent with button
const variants = ['destructive', 'creative', 'recording', 'canceling']

/**
 * Button that executes a callback after a given time.
 *
 * @preset Default { "props": { "label": "Destroy", "icon": "doc:trash" } }
 * @propsGroup Display  [variant]
 * @propsGroup Behavior [timeout, noTextOnSmall]
 * @propsGroup Content  [label, toggleLabel, icon]
 */
export default {
  name: 'RuiTimeOutButton',
  emits: [
    'timed-out',
  ],
  components: { RuiIcon },
  props: {
    /** Button text */
    label: { required: false, type: String, default: null },
    /** Alternative text when timeout is active */
    toggleLabel: { required: false, type: String, default: null },
    /** Timeout duration */
    timeout: { required: false, type: Number, default: 2000 },
    /** Timeout duration */
    variant: { required: false, type: String, default: 'destructive', validator: v => variants.includes(v) },
    /** Optional icon */
    icon: { required: false, type: String, default: null },
    /** Whether to hide the text on small screens */
    noTextOnSmall: { required: false, type: Boolean, default: false },
  },
  data () {
    return {
      percentage: 100,
      processing: false,
      width: null,
    }
  },
  computed: {
    buttonStyle () {
      if (!this.processing) return {}

      return { width: `${this.width}px` }
    },
    buttonCSS () {
      return [
        this.$props.variant && `rui-timeout-button--${this.$props.variant}`,
        this.$props.variant && 'rui-timeout-button--no-text-on-small',
      ]
    },
    backgroundStyle () {
      return {
        width: `${this.percentage}%`,
        transition: `width linear ${this.transitionDuration}ms`,
      }
    },
    backgroundCSS () {
      return [
        this.processing && this.percentage < 100 && 'rui-timeout-button__background--decreasing',
      ]
    },
    transitionDuration () { return this.$props.timeout / 10 },
  },
  methods: {
    setTimeOut () {
      setTimeout(() => {
        if (!this.processing) return
        this.percentage -= 10

        if (this.percentage <= 0) this.handleTimeOut()
        else this.setTimeOut()
      }, this.transitionDuration)
    },
    handleTimeOut () {
      this.processing = false
      /** Fired when time out is over */
      this.$emit('timed-out')
    },
    handleClick () {
      this.percentage = 100

      if (this.processing) {
        this.processing = false
      } else {
        this.width = this.$el.clientWidth
        this.processing = true
        this.setTimeOut()
      }
    },
  },
}
</script>
